unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, StdCtrls, ShellApi;

type
  TStringDynArray = array of string;

  TMainForm = class(TForm)
    mmoDiary: TMemo;
    pnlTop: TPanel;
    lblDay: TLabel;
    pnlLeft: TPanel;
    mntCalendar: TMonthCalendar;
    pnlAnlagen: TPanel;
    StatusBar: TStatusBar;
    procedure mntCalendarClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure pnlAnlagenClick(Sender: TObject);
    procedure StatusBarClick(Sender: TObject);
  public
    alt_datum: string;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

function ZweiNull(inp: integer): string;
begin
  if (inp > -1) and (inp < 10) then
    result := '0' + inttostr(inp)
  else
    result := inttostr(inp);
end;

function Explode(const Separator, S: string; Limit: Integer = 0):
  TStringDynArray;
var
  SepLen       : Integer;
  F, P         : PChar;
  ALen, Index  : Integer;
begin
  SetLength(Result, 0);
  if (S = '') or (Limit < 0) then
    Exit;
  if Separator = '' then
  begin
    SetLength(Result, 1);
    Result[0] := S;
    Exit;
  end;
  SepLen := Length(Separator);
  ALen := Limit;
  SetLength(Result, ALen);

  Index := 0;
  P := PChar(S);
  while P^ <> #0 do
  begin
    F := P;
    P := StrPos(P, PChar(Separator));
    if (P = nil) or ((Limit > 0) and (Index = Limit - 1)) then
      P := StrEnd(F);
    if Index >= ALen then
    begin
      Inc(ALen, 5); // mehrere auf einmal um schneller arbeiten zu knnen
      SetLength(Result, ALen);
    end;
    SetString(Result[Index], F, P - F);
    Inc(Index);
    if P^ <> #0 then
      Inc(P, SepLen);
  end;
  if Index < ALen then
    SetLength(Result, Index); // wirkliche Lnge festlegen
end;

// Umwandlung von D-M-YYYY in YYYY-MM-DD
procedure VerzeichnisseUmbenennen(LDir: String);
var
  LSRec: TSearchRec;
  I, E: integer;
  StringArray: TStringDynArray;
begin
  if FindFirst(LDir + '\*', faAnyFile, LSRec) = 0 then
  begin
    repeat
      if (LSRec.Name <> '.') and (LSRec.Name <> '..') then
      begin
        Val(copy(LSRec.Name, 0, 4), I, E);
        if E <> 0 then
        begin
          StringArray := Explode('-', LSRec.Name);
          RenameFile('Data\'+LSRec.Name, 'Data\'+copy(StringArray[2], 0, length(StringArray[2])-length(extractfileext(LDir+'\'+LSRec.Name)))+'-'+ZweiNull(strtoint(StringArray[1]))+'-'+ZweiNull(strtoint(StringArray[0]))+extractfileext(LDir+'\'+LSRec.Name));
        end;
      end;
    until (FindNext(LSRec) <> 0);
  end;
  FindClose(LSRec);
end;

procedure DeleteEmptyDirs(LDir: String);
var
  LSRec: TSearchRec;
begin
  if FindFirst(LDir + '\*', faAnyFile, LSRec) = 0 then
  begin
    repeat
      if (faDirectory and LSRec.Attr <> 0) and (LSRec.Name <> '.') and (LSRec.Name <> '..') then
      begin
        // Wirkt nur, wenn leer...
        RemoveDirectory(pchar(LDir+'\'+LSRec.Name));
      end;
    until (FindNext(LSRec) <> 0);
  end;
  FindClose(LSRec);
end;

procedure TMainForm.mntCalendarClick(Sender: TObject);
var
  wday, Year, Month, Day: word;
  wdayex, MonthEx: string;
begin
  wday := DayOfWeek(mntCalendar.date);
  if wday = 1 then wdayex := 'Sonntag';
  if wday = 2 then wdayex := 'Montag';
  if wday = 3 then wdayex := 'Dienstag';
  if wday = 4 then wdayex := 'Mittwoch';
  if wday = 5 then wdayex := 'Donnerstag';
  if wday = 6 then wdayex := 'Freitag';
  if wday = 7 then wdayex := 'Samstag';
  DecodeDate(mntCalendar.date, Year, Month, Day);
  if Month = 1 then MonthEx := 'Januar';
  if Month = 2 then MonthEx := 'Februar';
  if Month = 3 then MonthEx := 'Mrz';
  if Month = 4 then MonthEx := 'April';
  if Month = 5 then MonthEx := 'Mai';
  if Month = 6 then MonthEx := 'Juni';
  if Month = 7 then MonthEx := 'Juli';
  if Month = 8 then MonthEx := 'August';
  if Month = 9 then MonthEx := 'September';
  if Month = 10 then MonthEx := 'Oktober';
  if Month = 11 then MonthEx := 'November';
  if Month = 12 then MonthEx := 'Dezember';
  lblDay.Caption := wdayex+', der '+inttostr(Day)+'. '+MonthEx+' '+inttostr(Year);
  if alt_datum <> '' then
    mmoDiary.Lines.SaveToFile(extractfilepath(paramstr(0))+'Data\'+alt_datum+'.txt');
  if mmoDiary.Lines.Text = '' then
    DeleteFile(extractfilepath(paramstr(0))+'Data\'+alt_datum+'.txt');
  if fileexists(extractfilepath(paramstr(0))+'Data\'+inttostr(Year)+'-'+ZweiNull(Month)+'-'+ZweiNull(Day)+'.txt') then
    mmoDiary.Lines.LoadFromFile(extractfilepath(paramstr(0))+'Data\'+inttostr(Year)+'-'+ZweiNull(Month)+'-'+ZweiNull(Day)+'.txt')
  else
    mmoDiary.Lines.Clear;
  alt_datum := inttostr(Year)+'-'+ZweiNull(Month)+'-'+ZweiNull(Day);
  if directoryexists('Data\'+alt_datum) then
    pnlAnlagen.Font.Color := clActiveCaption
  else
    pnlAnlagen.Font.Color := clAppWorkSpace;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  {$I-}
  if not directoryexists(extractfilepath(paramstr(0))+'Data') then
    MkDir(extractfilepath(paramstr(0))+'Data');
  {$I+}
  VerzeichnisseUmbenennen('Data');
  mntCalendar.Date := now();
  mntCalendarClick(self);
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if alt_datum <> '' then
    mmoDiary.Lines.SaveToFile(extractfilepath(paramstr(0))+'Data\'+alt_datum+'.txt');
  if mmoDiary.Lines.Text = '' then
    DeleteFile(extractfilepath(paramstr(0))+'Data\'+alt_datum+'.txt');
  DeleteEmptyDirs('Data');
end;

procedure TMainForm.pnlAnlagenClick(Sender: TObject);
begin
  {$I-}
  if not directoryexists(extractfilepath(paramstr(0))+'Data\'+alt_datum) then
    MkDir(extractfilepath(paramstr(0))+'Data\'+alt_datum);
  {$I+}
  if directoryexists(extractfilepath(paramstr(0))+'Data\'+alt_datum) then
  begin
    ShellExecute(Handle, 'open', pchar(extractfilepath(paramstr(0))+'Data\'+alt_datum), nil, nil, SW_SHOWNORMAL);
    pnlAnlagen.Font.Color := clActiveCaption;
  end;
end;

procedure TMainForm.StatusBarClick(Sender: TObject);
begin
  shellexecute(application.Handle, 'open', 'http://www.viathinksoft.de/', '', '', SW_NORMAL);
end;

end.
